﻿#もうひとつの回帰分析　自作関数

#6章シュミレーション関数
conjyo.sim<-function(data,design,label,num=3){
   x<-colMeans(caPartUtilities(data,design,label))
   ss<-select.list(names(x),graphics=T,multiple= T)
   print(round(x[rownames=ss],num))
   print("総効用値")
   print(round(sum(x[rownames=ss]),num))
}


#6章結果のプロット関数
plot.Conjoint <- function(utility,label,sd=FALSE)
{
	if(sd==FALSE){
		names(utility)<-NULL
		#切片の削除
		utility<-utility[-1]
		#プロット順になるようにベクトルを反対に
		utility<-rev(utility)
		cname<-rev(label)
		barplot(utility, horiz=TRUE, xlab="部分効用値",xlim=c(-0.6,0.6))
		text(0, 1.2*(1:length(cname)-0.5),cname,pos=ifelse(utility > 0, 2, 4))
	}else{
		names(utility)<-NULL
		#切片の削除
		utility<-utility[-1]
		#プロット順になるようにベクトルを反対に
		utility<-rev(utility)
		cname<-c("個人差","個人差",rev(label))
		barplot(c(sd,-sd,utility), horiz=TRUE, xlab="部分効用値")
		text(0, 1.2*(1:length(cname)-0.5),cname,pos=ifelse(utility > 0, 2, 4))
	}
}

#6章の個人重要度関数
sub.imp<-function(data,design,label){
uslall<-caPartUtilities(data,design,label)[,-1] 
np<-ncol(design)
nl<-as.numeric(np)
for(i in 1:np){
	nl[i]<-length(unique(design[,i]))
}
nl_cum<-c(0,cumsum(nl)) 
nx<-nrow(data) 
R2<-matrix(numeric(np*nx),nx,np)
for(x in 1:nx){
	for(i in 1:np){
   		a<-nl_cum[i]+1
   		b<-nl_cum[i+1]
   		R2[x,i]<-max(uslall[x,a:b])-min(uslall[x,a:b])
     }
}
imp_new2<-matrix(numeric(np*nx),nx,np)
for(x in 1:nx){
	for(i in 1:np){
    	imp_new2[x,i]<-R2[x,i]/sum(R2[x,])*100
    }
}
colnames(imp_new2)<-colnames(design)
imp_new2<-round(imp_new2,3)
return(imp_new2)
}


#7.2 効果量

effectsize<-function(x1,x2,toubunsan=TRUE){         
        if(toubunsan==TRUE){                                    
           n<-ncol(x1)
           M<-matrix(numeric(n),1,n)
	     x<-rbind(x1,x2)
	     sigma<-numeric(n)
           for(i in 1:n){
	       sigma[i]<-sqrt((nrow(x)-1)/(nrow(x))*var(x[,i])) 
             M[i]<-(mean(x1[,i])-mean(x2[,i]))/sigma[i]
         }
         M<-round(M,3)
         rownames(M)<-"delta"
         colnames(M)<-c("切片","性別","年齢","被害者人数","逮捕経緯","殺害経緯","前科","処罰感情")
         return(M)
         }
         else{
             n<-ncol(x1)
             M<-matrix(numeric(n*2),2,n)
             sigma1<-numeric(n)
             sigma2<-numeric(n)
             for(i in 1:n){
               sigma1[i]<-sqrt((nrow(x1)-1)/(nrow(x1))*var(x1[,i]))
               sigma2[i]<-sqrt((nrow(x2)-1)/(nrow(x2))*var(x2[,i]))
               M[1,i]<-(mean(x1[,i])-mean(x2[,i]))/sigma1[i]
               M[2,i]<-(mean(x1[,i])-mean(x2[,i]))/sigma2[i]
             }
          M<-round(M,3)
          rownames(M)<-c("delta1","delta2")
	    colnames(M)<-c("切片","性別","年齢","被害者人数","逮捕経緯","殺害経緯","前科","処罰感情")
          return(M)
         }
}

#7.3 非重複度
cohen_u3<-function(x1,x2,toubunsan=TRUE){          
        if(toubunsan==TRUE){                        
           n<-ncol(x1)
           M<-matrix(numeric(n),1,n)
	     x<-rbind(x1,x2)
	     sigma<-numeric(n)
             for(i in 1:n){
	       sigma[i]<-sqrt((nrow(x)-1)/(nrow(x))*var(x[,i])) 
             M[1,i]<-pnorm(mean(x1[,i]),mean(x2[,i]),sigma[i])
         }
         M<-round(M,3)
         rownames(M)<-c("U3")
	   colnames(M)<-c("切片","性別","年齢","被害者人数","逮捕経緯","殺害経緯","前科","処罰感情")
         return(M)
         }
         else{
             n<-ncol(x1)
             M<-matrix(numeric(n*2),2,n)
             sigma1<-numeric(n)
             sigma2<-numeric(n)
             for(i in 1:n){
             sigma1[i]<-sqrt((nrow(x1)-1)/(nrow(x1))*var(x1[,i]))
             sigma2[i]<-sqrt((nrow(x2)-1)/(nrow(x2))*var(x2[,i]))
             M[1,i]<-pnorm(mean(x1[,i]),mean(x2[,i]),sigma2[i])
             M[2,i]<-1-pnorm(mean(x2[,i]),mean(x1[,i]),sigma1[i])
         }
          M<-round(M,3)
          rownames(M)<-c("U31","U32")
	    colnames(M)<-c("切片","性別","年齢","被害者人数","逮捕経緯","殺害経緯","前科","処罰感情")
          return(M)
         }
}

#7.4 優越率
pid<-function(x1,x2,toubunsan=TRUE){   
        if(toubunsan==TRUE){                        
           n<-ncol(x1)
	     x<-rbind(x1,x2)
	     sigma<-numeric(n)
           delta<-numeric(n)
           Pd<-matrix(numeric(n),1,n)
           for(i in 1:n){
	       sigma[i]<-sqrt((nrow(x)-1)/(nrow(x))*var(x[,i])) 
             delta[i]<-(mean(x1[,i])-mean(x2[,i]))/sigma[i]
             Pd[i]<-pnorm( (delta[i]/sqrt(2)) ,0,1) 
           }
        Pd<-round(Pd,3)
        rownames(Pd)<-c("優越率(等分散)")
	  colnames(Pd)<-c("切片","性別","年齢","被害者人数","逮捕経緯","殺害経緯","前科","処罰感情")
        return(Pd)
        }
        else{
           n<-ncol(x1)
           Pd<-matrix(numeric(n),1,n)
           sigma1<-numeric(n)
           sigma2<-numeric(n)
           z<-numeric(n)
           for(i in 1:n){
             sigma1[i]<-sqrt((nrow(x1)-1)/(nrow(x1))*var(x1[,i]))
             sigma2[i]<-sqrt((nrow(x2)-1)/(nrow(x2))*var(x2[,i]))
             z[i]<-(mean(x1[,i])-mean(x2[,i]))/(sqrt(sigma1[i]^2+sigma2[i]^2))
             Pd[i]<-pnorm( z[i], 0,1)
        }
        Pd<-round(Pd,3)
        rownames(Pd)<-c("優越率(異分散)")
	  colnames(Pd)<-c("切片","性別","年齢","被害者人数","逮捕経緯","殺害経緯","前科","処罰感情")
        return(Pd)
        }
}

#7.5 閾上率
pic<-function(x1,x2,c,toubunsan=TRUE){   
        if(toubunsan==TRUE){                        
           n<-ncol(x1)
	     x<-rbind(x1,x2)
	     sigma<-numeric(n)
           z<-numeric(n)
           Pc<-matrix(numeric(n),1,n)
           for(i in 1:n){
	       sigma[i]<-sqrt((nrow(x)-1)/(nrow(x))*var(x[,i]))
             z[i]<-( mean(x1[,i])-mean(x2[,i])-c)/(sqrt(2)*sigma[i]) 
             Pc[i]<-pnorm( z[i] ,0,1) 
           }
        Pc<-round(Pc,3)
        rownames(Pc)<-c("閾上率(等分散)")
	  colnames(Pc)<-c("切片","性別","年齢","被害者人数","逮捕経緯","殺害経緯","前科","処罰感情")
        return(Pc)
        }
        else{
           n<-ncol(x1)
           Pc<-matrix(numeric(n),1,n)
           sigma1<-numeric(n)
           sigma2<-numeric(n)
           z<-numeric(n)
           for(i in 1:n){
             sigma1[i]<-sqrt((nrow(x1)-1)/(nrow(x1))*var(x1[,i]))
             sigma2[i]<-sqrt((nrow(x2)-1)/(nrow(x2))*var(x2[,i]))
             z[i]<-(mean(x1[,i])-mean(x2[,i])-c)/(sqrt(sigma1[i]^2+sigma2[i]^2))
             Pc[i]<-pnorm( z[i], 0,1)
        }
        Pc<-round(Pc,3)
        rownames(Pc)<-c("閾上率(異分散)")
	  colnames(Pc)<-c("切片","性別","年齢","被害者人数","逮捕経緯","殺害経緯","前科","処罰感情")
        return(Pc)
        }
}



#表8.2平均 
M<-function(x){
n<-ncol(x)
M<-numeric(n)
 for(i in 1:n){
 m<-i
 M[m]<-mean(x[,m])
 }
round(M,3)
}

#表8.2標準偏差
SD<-function(x){
n<-ncol(x)
S<-numeric(n)
 for(i in 1:n){
 m<-i
 S[m]<-sqrt((nrow(x)-1)/(nrow(x))*var(x[,i])) 
 }
round(S,3)
}


#8.2.1差得点の効果量
diff_effectsize<-function(x,toubunsan=TRUE){      
      if(toubunsan==TRUE){
        n<-ncol(x)
        M<-matrix(numeric(n*n),n,n)
        sigma<-numeric(n)
        for(i in 1:n){
        for(j in 1:n){
        sigma[i]<-sqrt((nrow(x)-1)/(nrow(x))*var(x[,i]))
        M[i,j]<-(mean(x[,i])-mean(x[,j]))/(sigma[i]*sqrt(2*(1-cor(x[,i],x[,j]))))
             }
             }
             }
      else{  
        n<-ncol(x)
        M<-matrix(numeric(n*n),n,n)
        sigma1<-numeric(n)
        sigma2<-numeric(n)
        for(i in 1:n){
        for(j in 1:n){
        sigma1[i]<-sqrt((nrow(x)-1)/(nrow(x))*var(x[,i]))
        sigma2[j]<-sqrt((nrow(x)-1)/(nrow(x))*var(x[,j]))
        M[i,j]<-(mean(x[,i])-mean(x[,j]))/(sqrt((sigma1[i])^2+(sigma2[j])^2-2*cor(x[,i],x[,j])*sigma1[i]*sigma2[j]))
             }
             }
             }
          M<-round(M,3)
          rownames(M)<-c("切片","性別","年齢","被害者人数","逮捕経緯","殺害経緯","前科","処罰感情")
	    colnames(M)<-c("切片","性別","年齢","被害者人数","逮捕経緯","殺害経緯","前科","処罰感情")
          return(M)
         }

#8.2.2差得点の優越率
diff_pid<-function(x,toubunsan=TRUE){   
       if(toubunsan==TRUE){
           n<-ncol(x)
           Pd<-matrix(numeric(n*n),n,n)
           sigma<-numeric(n)
           z<-matrix(numeric(n*n),n,n)
           for(i in 1:n){
           for(j in 1:n){
             sigma[i]<-sqrt((nrow(x)-1)/(nrow(x))*var(x[,i]))
             z[i,j]<-(mean(x[,i])-mean(x[,j]))/(sigma[i]*sqrt(2))
             Pd[i,j]<-pnorm(z[i,j],0,1)
                        }
                        }
                        }
        else{
           n<-ncol(x)
           Pd<-matrix(numeric(n*n),n,n)
           sigma1<-numeric(n)
           sigma2<-numeric(n)
           z<-matrix(numeric(n*n),n,n)
           for(i in 1:n){
           for(j in 1:n){
             sigma1[i]<-sqrt((nrow(x)-1)/(nrow(x))*var(x[,i]))
             sigma2[j]<-sqrt((nrow(x)-1)/(nrow(x))*var(x[,j]))
             z[i,j]<-(mean(x[,i])-mean(x[,j]))/(sqrt((sigma1[i])^2+(sigma2[j])^2-2*cor(x[,i],x[,j])*sigma1[i]*sigma2[j]))
             Pd[i,j]<-pnorm(z[i,j],0,1)
                        }
                        }
                        }
        Pd<-round(Pd,3)
        rownames(Pd)<-c("切片","性別","年齢","被害者人数","逮捕経緯","殺害経緯","前科","処罰感情")
	  colnames(Pd)<-c("切片","性別","年齢","被害者人数","逮捕経緯","殺害経緯","前科","処罰感情")
        return(Pd)
        }


#8.2.3差得点の閾上率
diff_pic<-function(x,c,toubunsan=TRUE){
        if(toubunsan==TRUE){
           n<-ncol(x)
           Pc<-matrix(numeric(n*n),n,n)
           sigma<-numeric(n)
           z<-matrix(numeric(n*n),n,n)
           for(i in 1:n){
           for(j in 1:n){
             sigma[i]<-sqrt((nrow(x)-1)/(nrow(x))*var(x[,i]))
             z[i,j]<-(mean(x[,i])-mean(x[,j])-c)/(sigma[i]*sqrt(2*(1-cor(x[,i],x[,j]))))
             Pc[i,j]<-pnorm(z[i,j],0,1)
                        }
                        }
                        }
         else{
           n<-ncol(x)
           Pc<-matrix(numeric(n*n),n,n)
           sigma1<-numeric(n)
           sigma2<-numeric(n)
           z<-matrix(numeric(n*n),n,n)
           for(i in 1:n){
           for(j in 1:n){
             sigma1[i]<-sqrt((nrow(x)-1)/(nrow(x))*var(x[,i]))
             sigma2[i]<-sqrt((nrow(x)-1)/(nrow(x))*var(x[,j]))
             z[i,j]<-(mean(x[,i])-mean(x[,j])-c)/(sqrt((sigma1[i])^2+(sigma2[j])^2-2*cor(x[,i],x[,j])*sigma1[i]*sigma2[j]))
             Pc[i,j]<-pnorm(z[i,j],0,1)
                        }
                        }
                        }
        Pc<-round(Pc,3)
        rownames(Pc)<-c("切片","性別","年齢","被害者人数","逮捕経緯","殺害経緯","前科","処罰感情")
 	  colnames(Pc)<-c("切片","性別","年齢","被害者人数","逮捕経緯","殺害経緯","前科","処罰感情")
        return(Pc)
        }








