data {
  int<lower=0> n1;
  int<lower=0> n2; //データ数
  array[n1] real x1;
  array[n2] real x2; //データ
  real EQU; //ＳＤ、1 - 共通、0 - 異なる
  real mL;
  real mH;
  real sL;
  real sH; //事前分布
}
parameters {
  vector<lower=mL, upper=mH>[2] mu; //平均(範囲指定)
  real<lower=sL, upper=sH> sigma1; //標準偏差(範囲指定)
  real<lower=sL, upper=sH> dummy; //ダミーのＳＤ(範囲指定)
}
transformed parameters {
  real<lower=0> sigma2; //標準偏差2
  sigma2 = EQU > 0.5 ? sigma1 : dummy;
}
model {
  x1 ~ normal(mu[1], sigma1); //正規分布1
  x2 ~ normal(mu[2], sigma2); //正規分布2
}
generated quantities {
  array[2] real xaste;
  real log_lik;
  xaste[1] = normal_rng(mu[1], sigma1); //予測分布1
  xaste[2] = normal_rng(mu[2], sigma2); //予測分布2
  log_lik = normal_lpdf(x1 | mu[1], sigma1) + normal_lpdf(x2 | mu[2], sigma2); //対数尤度
}


